(******************             HOLG1000.INC              *******************


 TYPE       <>

     putpack                    registers


 GLOBAL     <>

     putvideo                   video type 1,mono 2,cga 3,ega


 FUNCTIONS  <>

   math
     saw(n,cycle)               1,2, ... ,n-1,n,n,n-1, ...
     max(i,j), min(i,j)         max, min
     swap(i,j), lowhi(i,j)      swap, swap if i>j
     rnd1(n)                    random(n)+1

   char/str

     ditchr(c,n)                ditto char c n times.
     ditstr(s,n)                ditto string s n times
     chr2(n1,n2)                make string 2 chr long
     chr4(n1,n2,n3,n4)          make string 4 chr long
     chr8(n1, ... ,n8)          make string 8 chr long
     rchr(s)                    random char of s


 PROCEDURES <>


     ticktock(r)                return time as real
     getputvideo                putvideo:  1,mono 2,cga 3,ega
     setblink(onoff)            0=off, else on
     c_f(f),c_b(b),c_a(f,b),
            c_e(e),c_s(f,b,e)   screen colors f,fore b,back e,edge
     putxy(x,y,f,b,s)           put string s @x,y colors f,b
     pvtxy(x,y,f,b,s)           put string s @x,y colors f,b VERTICLE
     putcy(  y,f,b,s)           "          " row y centered
     putxc(x  ,f,b,s)           "          " col x centered
     putbox(x1,y1,x2,y2,f,b,c)  put box corners xn,yn colors f,b char c
     putboxk(x1,y1,x2,y2,f,b,s) "                              " str8 s
     putboxt(x1,y1,x2,y2,f,b,t) "                              " type t
     putboxx(x1,y1,x2,y2,f)     "                             "  2x vert
     putrect(x1,y1,x2,y2,f,b,c) "   rect                       " char c
     putboxxc(x1,y1,x2,y2,f,b,c)        box with vert width 2 of char c
     putboxxp(x1,y1,x2,y2,f,b,c2)       box with vert width 2 of char pair c2
     putrectxx(x1,y1,x2,y2,f,b,c2)      rectangle of c,char f,b color
     putrectck(x1,y1,x2,y2,f,b,c2)      rectangle of c1,c2 checker board
     putrectsh(x1,y1,x2,y2,f ,b, c,
                        ds,fs,bs,cs)    rectangle of c,char f,b color
                                        with shadow direction 1-4,
                                        col fs,bs char cs
     putrectrs(x1,y1x2,y2,f,b,s)    rect of random chars in str s
     putpattern(x1,y1,x2,y2,f,b,n,s)rect of pattern n lines of str s
     put48(x,y,f,b,s)               4x8 char font
     put48c (y,f,b,s)               4x8 char font centered on y

  keys:
     inkey(k)                   TURBO scan code of keyboard (may be 0)
     waitkey(k)                 wait for TURBO scan code
     pause                      wait, no key returned
     drainkey                   drain keyboard
     keywinks(x,y,s)            returns key scan 'winking' str s


 ******************                                       *******************)

type
   str080           = string[ 80];
   str255           = string[255];
   putpack          = record
                         case integer of
                           1: (ax,bx,cx,dx,bp,si,di,ds,es,flags: integer);
                           2: (al,ah,bl,bh,cl,ch,dl,dh         :    byte);
                         end;

const
   putvideo: integer=0;

   khm=1071; kua=1072; kpu=1073;
   kla=1075; kun=1067; kra=1077;
   knd=1079; kda=1080; kpd=1081;

   kf1=1059; kf2=1060; kf3=1061; kf4=1062; kf5=1063;
   kf6=1064; kf7=1065; kf8=1066; kf9=1067; kf0=1068;


var
   b000video        : array[0..1999] of integer absolute $b000:0000;
   b800video        : array[0..1999] of integer absolute $b800:0000;
   b000videoc       : array[0..3999] of char    absolute $b000:0000;
   b800videoc       : array[0..3999] of char    absolute $b800:0000;


(* math *)

function saw(n,cycle: integer): integer;
var
   i,j,k            : integer;
begin
   i:=((n-1) mod cycle)+1;
   j:= (n-1) div cycle;
   if  (j mod 2)=1 then i:=cycle+1-i;
   saw:=i;
end;

function max(i,j: integer): integer;
   begin if (i>j) then max:=i else max:=j; end;

function min(i,j: integer): integer;
   begin if (i<j) then min:=i else min:=j; end;

procedure swap(var i,j: integer);
      var t: integer;
    begin t:=i; i:=j; j:=t; end;

procedure lowhi(var i,j: integer);
    begin if (i>j) then swap(i,j); end;

function rnd1(n: integer): integer;
   begin rnd1:=random(max(1,n))+1; end;


(* char, string *)

function ditchr(c: char; l: integer): str255;
var 
   s     : str255;
begin 
   l:=max(  0,l);
   l:=min(255,l);
   if (l<1) then begin ditchr:=''; exit; end;
   s[0]:=chr(l); fillchar(s[1],l,c); ditchr:=s; 
end;

function ditstr(s: str255; n: integer): str255;
     var i     : integer;
         w     : str255;
   begin w:=''; for i:=1 to n do w:=w+s; ditstr:=w; end;

function chr2(i,j: integer): str080;
var
   a                : integer;
   s                : str080;
begin
   s:=chr(i)+chr(j);
   for a:=1 to 2 do
      if (s[a]=chr(0)) then begin s[0]:=chr(a-1); chr2:=s; exit; end;
   chr2:=s;
end;

function chr4(i,j,k,l: integer): str080;
   begin chr4:=chr2(i,j)+chr2(k,l); end;

function chr8(i,j,k,l,m,n,o,p: integer): str080;
   begin chr8:=chr4(i,j,k,l)+chr4(m,n,o,p); end;

function rchr(s: str255): char;
   begin rchr:=s[rnd1(ord(s[0]))]; end;


(* system *)

procedure ticktock(var t: real);
var
   r                : putpack;
begin
   r.ah:=$2c;
   intr($21,r);
   t :=r.ch*360000. + r.cl*6000. + r.dh*100. + r.dl;
end;

procedure getputvideo;
var
   r                : putpack;
begin
   r.ah:=$0f;
   intr($10,r);
   if (r.al=7)
      then putvideo:=1
      else
         begin
         r.ah:=$12;
         r.bx:=$10;
         intr($10,r);
         if (r.bx=$10) then putvideo:=2
                       else putvideo:=3;
         end;
end;

procedure setblink(i: integer);
    begin if (i=0) then port[$3d8]:=9 else port[$3d8]:=41; end;

(* video *)

procedure c_f(i    : integer);  begin textcolor     (i mod 32); end;
procedure c_b(i    : integer);  begin textbackground(i mod  8); end;
procedure c_a(i,j  : integer);  begin c_f(i); c_b(j);           end;
procedure c_e(i    : integer);
var
   r                : putpack;
begin
   case putvideo of
      3 : begin
          if (i>7) then i:=i+48;
          r.ah:=$10;
          r.al:=  1;
          r.bh:=  i;
          intr($10,r);
          end;
     else port[$3d9]:=i;
    end;
end;
procedure c_s(i,j,k: integer);  begin c_a(i,j); c_e(k);         end;

procedure putxy(x,y,f,b: integer; s: str080);
var
   i,l,xy,video       : integer;
   attr               : byte;
   c                  : char;
   sp                 : ^str080;
   r                  : putpack;
begin
   if (putvideo=0) then getputvideo;
   l:=ord(s[0]);
   if not (x in [1..80]) then exit;
   if not (y in [1..25]) then exit;
   if (x+l)>81 then l:=81-x;
   attr:=16*b+f;
   case putvideo of
      1 : begin
          xy:=(x-1)+80*(y-1);
          for i:=1 to l do b000video[xy+i-1]:=ord(s[i])+256*attr;
          end;
      3 : begin
          xy:=(x-1)+80*(y-1);
          for i:=1 to l do b800video[xy+i-1]:=ord(s[i])+256*attr;
          end;
      2 : begin
          xy:=2*(x-1+80*(y-1))-2;
          video:=$b800;
          for i:=1 to l do
             begin
             c:=s[i];
             xy:=xy+2;
inline(
       $8a/$9e/c/            {    mov     bl,c              }
       $8a/$be/attr/         {    mov     bh,attr           }
       $8e/$86/video/        {    mov     es,video          }
       $8b/$86/xy/           {    mov     ax,xy             }
       $8b/$f8/              {    mov     di,ax             }
       $ba/$da/03/           {    mov     dx,03dah          }
       $ec/                  {low:in      al,dx             }
       $a8/$01/              {    test    al,1              }
       $75/$fb/              {    jnz     low               }
       $fa/                  {    cli                       }
       $ec/                  {hi: in      al,dx             }
       $a8/$01/              {    test    al,1              }
       $74/$fb/              {    jz      hi                }
       $8b/$c3/              {    mov     ax,bx             }
       $ab/                  {    stosw                     }
       $fb                   {    sti                       }
       );
             end;
          end;
   end;
end;

procedure pvtxy(x,y,f,b: integer; s: str080);
var
   i,l,xy,video       : integer;
   attr               : byte;
   c                  : char;
   sp                 : ^str080;
   r                  : putpack;
begin
   if (putvideo=0) then getputvideo;
   l:=ord(s[0]);
   if not (x in [1..80]) then exit;
   if not (y in [1..25]) then exit;
   if (y+l)>26 then l:=26-y;
   attr:=16*b+f;
   case putvideo of
      1 : begin
          xy:=(x-1)+80*(y-1)-80;
          for i:=1 to l do b000video[xy+i*80]:=ord(s[i])+256*attr;
          end;
      3 : begin
          xy:=(x-1)+80*(y-1)-80;
          for i:=1 to l do b800video[xy+i*80]:=ord(s[i])+256*attr;
          end;
      2 : begin
          xy:=2*(x-1+80*(y-1))-160;
          video:=$b800;
          for i:=1 to l do
             begin
             c:=s[i];
             xy:=xy+160;
inline(
       $8a/$9e/c/            {    mov     bl,c              }
       $8a/$be/attr/         {    mov     bh,attr           }
       $8e/$86/video/        {    mov     es,video          }
       $8b/$86/xy/           {    mov     ax,xy             }
       $8b/$f8/              {    mov     di,ax             }
       $ba/$da/03/           {    mov     dx,03dah          }
       $ec/                  {low:in      al,dx             }
       $a8/$01/              {    test    al,1              }
       $75/$fb/              {    jnz     low               }
       $fa/                  {    cli                       }
       $ec/                  {hi: in      al,dx             }
       $a8/$01/              {    test    al,1              }
       $74/$fb/              {    jz      hi                }
       $8b/$c3/              {    mov     ax,bx             }
       $ab/                  {    stosw                     }
       $fb                   {    sti                       }
       );
             end;
          end;
   end;
end;

procedure putcy(y,f,b: integer; s: str080);
    begin putxy(41-(length(s) div 2),y,f,b,s); end;

procedure putxc(x,f,b: integer; s: str080);
    begin pvtxy(x,13-(length(s) div 2),f,b,s); end;

procedure putxysa(x,y,d: integer; s: str255);
var
   i,l,l2,xy,video    : integer;
   c,attr             : char;
begin
   d:=d+d;
   if (putvideo=0) then getputvideo;
   l:=ord(s[0]);
   l2:=l div 2;
   if not (x in [1..80]) then exit;
   if not (y in [1..25]) then exit;
   case putvideo of
      1 : begin
          xy:=2*(x-1+80*(y-1))-d;
          for i:=1 to l2 do
             begin
             xy:=xy+d;
             b000videoc[xy  ]:=s[i+i-1];
             b000videoc[xy+1]:=s[i+i  ];
             end;
          end;
      3 : begin
          xy:=2*(x-1+80*(y-1))-d;
          for i:=1 to l2 do
             begin
             xy:=xy+d;
             b800videoc[xy  ]:=s[i+i-1];
             b800videoc[xy+1]:=s[i+i  ];
             end;
          end;
      2 : begin
          xy:=2*(x-1+80*(y-1))-d;
          video:=$b800;
          for i:=1 to l2 do
             begin
             c   :=s[i+i-1];
             attr:=s[i+i];
             xy  :=xy+d;
inline(
       $8a/$9e/c/            {    mov     bl,c              }
       $8a/$be/attr/         {    mov     bh,attr           }
       $8e/$86/video/        {    mov     es,video          }
       $8b/$86/xy/           {    mov     ax,xy             }
       $8b/$f8/              {    mov     di,ax             }
       $ba/$da/03/           {    mov     dx,03dah          }
       $ec/                  {low:in      al,dx             }
       $a8/$01/              {    test    al,1              }
       $75/$fb/              {    jnz     low               }
       $fa/                  {    cli                       }
       $ec/                  {hi: in      al,dx             }
       $a8/$01/              {    test    al,1              }
       $74/$fb/              {    jz      hi                }
       $8b/$c3/              {    mov     ax,bx             }
       $ab/                  {    stosw                     }
       $fb                   {    sti                       }
       );
             end;
          end;
   end;
end;

procedure putboxc(x1,y1,x2,y2,f,b: integer; c: char);
var
   i,j,k            : integer;
   s                : str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   fillchar(s[1],x2-x1+1,c); s[0]:=chr(x2-x1+1);
   putxy(x1,y1,f,b,s);
   putxy(x1,y2,f,b,s);
   if (y2-y1)<2 then exit;
   fillchar(s[1],y2-y1-1,c); s[0]:=chr(y2-y1-1);
   pvtxy(x1,y1+1,f,b,s);
   pvtxy(x2,y1+1,f,b,s);
end;

procedure putboxk(x1,y1,x2,y2,f,b: integer; s: str080);
var
   xl,yl            : integer;
   ts,bs,rs,ls      : str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   s:=s+'        ';
   xl:=x2-x1+1;
   fillchar(ts[1],xl,s[2]); ts[0]:=chr(xl);
   ts[ 1]:=s[1];
   ts[xl]:=s[3];
   fillchar(bs[1],xl,s[6]); bs[0]:=chr(xl);
   bs[ 1]:=s[7];
   bs[xl]:=s[5];
   putxy(x1,y1,f,b,ts);
   putxy(x1,y2,f,b,bs);
   yl:=y2-y1+1;
   if (yl>1) then
      begin
      fillchar(rs[1],yl-2,s[4]); rs[0]:=chr(yl-2);
      fillchar(ls[1],yl-2,s[8]); ls[0]:=chr(yl-2);
      pvtxy(x1,y1+1,f,b,ls);
      pvtxy(x2,y1+1,f,b,rs);
      end;
end;

procedure putboxt(x1,y1,x2,y2,f,b,t: integer);
var
   s                : str080;
begin
   case t of
      0   : s:='        ';
      1   : s:='Ŀ';
      2   : s:='ͻȺ';
      3   : s:='ķӺ';
      4   : s:='͸Գ';
      5   : s:='';
      6   : s:='';
      7   : s:='';
      8   : s:='';
      9   : s:=chr8(32,31,32,17,32,30,32,16);         (* solid arrows in  *)
     10   : s:=chr8(32,30,32,16,32,31,32,17);         (* solid arrows out *)
     11   : s:=chr8(32,25,32,27,32,24,32,26);         (*       arrows in  *)
     12   : s:=chr8(32,24,32,26,32,25,32,27);         (*       arrows out *)
     13   : s:=chr8(32,18,32,29,32,18,32,29);         (* double arrows    *)
     14   : s:=chr8(220,220,220,219,223,223,223,219); (* small box in     *)
     15   : s:=chr8(219,223,219,219,219,220,219,219); (* small box out    *)
     16   : s:='¿';
     17   : s:='Ŵ';
     18   : s:='˻';
     19   : s:='ι';
   else     s:='????????';
   end;
   putboxk(x1,y1,x2,y2,f,b,s);
end;

procedure putboxx(x1,y1,x2,y2,f: integer);
begin
   lowhi(x1,x2); lowhi(y1,y2);
   putboxc(x1,y1,x2,y2,f,0,chr(219));
   pvtxy(x1+1,y1+1,f,0,ditchr(chr(219),y2-y1-1));
   pvtxy(x2-1,y1+1,f,0,ditchr(chr(219),y2-y1-1));
end;

procedure putrect(x1,y1,x2,y2,f,b: integer; c: char);
var
   i,j,k            : integer;
   s                : str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   fillchar(s[1],x2-x1+1,c); s[0]:=chr(x2-x1+1);
   for i:=y1 to y2 do putxy(x1,i,f,b,s);
end;

procedure putboxxc(x1,y1,x2,y2,f,b: integer; c: char);
begin
   putboxc(x1,y1,x2,y2,f,b,c);
   lowhi(x1,x2); lowhi(y1,y2);
   pvtxy(x1+1,y1+1,f,b,ditchr(c,y2-y1-1));
   pvtxy(x2-1,y1+1,f,b,ditchr(c,y2-y1-1));
end;

procedure putboxxp(x1,y1,x2,y2,f,b: integer; c: str080);
var
   s                : str080;
begin
   c:=copy(c+'  ',1,2);
   lowhi(x1,x2); lowhi(y1,y2);
   if ((x2-x1) mod 2=0) then x2:=x2-1;
   s:=ditstr(c,(x2-x1+1) div 2);
   putxy(x1,y1,f,b,s);
   putxy(x1,y2,f,b,s);
   s:=ditchr(copy(c,1,1),y2-y1-1);
   pvtxy(x1  ,y1+1,f,b,s);
   pvtxy(x2-1,y1+1,f,b,s);
   s:=ditchr(copy(c,2,1),y2-y1-1);
   pvtxy(x1+1,y1+1,f,b,s);
   pvtxy(x2  ,y1+1,f,b,s);
end;

procedure putrectxx(x1,y1,x2,y2,f,b: integer; c: str080);
var
   i                : integer;
   c1,c2            : char;
   s1,s2            : str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   c:=copy(c+'  ',1,2);
   s1:='';
   for i:=1 to x2-x1+1 do s1:=s1+copy(c,1+((i+1) mod 2),1);
   for i:=y1 to y2 do putxy(x1,i,f,b,s1);
end;

procedure putrectck(x1,y1,x2,y2,f,b: integer; c: str080);
var
   i                : integer;
   c1,c2            : char;
   s1,s2            : str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   c:=copy(c+'  ',1,2);
   c1:=copy(c,1,1);
   c2:=copy(c,2,1);
   s1:=''; s2:='';
   for i:=1 to x2-x1+1 do
      if (i mod 2=1) then begin s1:=s1+c1; s2:=s2+c2; end
                     else begin s1:=s1+c2; s2:=s2+c1; end;
    for i:=y1 to y2 do
      if ((i-y1) mod 2=0) then putxy(x1,i,f,b,s1)
                          else putxy(x1,i,f,b,s2);
end;

procedure putrectsh(x1,y1,x2,y2,f,b: integer; c: char;
                            d,fs,bs: integer;c1: char);
var
   xl,yl            : integer;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   putrect(x1,y1,x2,y2,f,b,c);
   xl:=x2-x1+1;
   yl:=y2-y1+1;
   case d of
      1 : begin putxy(x1+2,y1-1,fs,bs,ditchr(c1,xl));
                pvtxy(x2+1,y1-1,fs,bs,ditchr(c1,yl));
                pvtxy(x2+2,y1-1,fs,bs,ditchr(c1,yl)); end;
      2 : begin putxy(x1+2,y2+1,fs,bs,ditchr(c1,xl));
                pvtxy(x2+1,y1+1,fs,bs,ditchr(c1,yl));
                pvtxy(x2+2,y1+1,fs,bs,ditchr(c1,yl)); end;
      3 : begin putxy(x1-2,y2+1,fs,bs,ditchr(c1,xl));
                pvtxy(x1-2,y1+1,fs,bs,ditchr(c1,yl));
                pvtxy(x1-1,y1+1,fs,bs,ditchr(c1,yl)); end;
      4 : begin putxy(x1-2,y1-1,fs,bs,ditchr(c1,xl));
                pvtxy(x1-2,y1-1,fs,bs,ditchr(c1,yl));
                pvtxy(x1-1,y1-1,fs,bs,ditchr(c1,yl)); end;
   end;
end;

procedure putrectrs(x1,y1,x2,y2,f,b: integer; s: str080);
var
   i,j,k            : integer;
   w                : str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   w[0]:=chr(x2-x1+1);
   k:=length(s);
   for j:=y1 to y2 do
      begin
      for i:=x1 to x2 do w[i-x1+1]:=s[random(k)+1];
      putxy(x1,j,f,b,w);
      end;
end;

procedure putpattern(x1,y1,x2,y2,f,b,n: integer; s: str080);
var
   i,j,xl,sln       : integer;
   s1               : str080;
   ss               : array[1..8] of str080;
begin
   lowhi(x1,x2);
   lowhi(y1,y2);
   xl:=x2-x1+1;
   n:=max(1,n);
   n:=min(8,n);
   if (s='') then s:='?';
   while (length(s) mod n>0) do s:=s+'?';
   sln:=length(s) div n;
   for i:=1 to n do
      begin
      s1:=copy(s,1+(i-1)*sln,sln);
      s1:=ditstr(s1,(xl div sln)+1);
      s1[0]:=chr(xl);
      ss[i]:=s1;
      end;
   for j:=y1 to y2 do
      putxy(x1,j,f,b,ss[((j-y1) mod n)+1]);
end;

function char48(c: char): str080;
var
   i,j,ij,n,i1,s    : integer;
   twos             : array[0..7] of integer;
   str              : str080;
begin
   str[0]:=chr(32);
   n:=ord(c);
   twos[0]:=1; for i:=1 to 7 do twos[i]:=2*twos[i-1];
   for i:=0 to 3 do
      for j:=0 to 7 do
         begin
         ij:=i*8+j+1;
         s:=0;
         i1:=n*8+i*2;
         if ord(mem[$f000:$fa6e+i1  ]) and twos[7-j]<>0 then s:=s+1;
         if ord(mem[$f000:$fa6e+i1+1]) and twos[7-j]<>0 then s:=s+2;
         case s of
            0 : str[ij]:=' ';
            1 : str[ij]:='';
            2 : str[ij]:='';
            3 : str[ij]:='';
         end;
         end;
   char48:=str;
end;

procedure put48(x,y,f,b: integer; s: str080);
var
   i,j,k,l          : integer;
   c                : char;
   sw               : str080;
begin
   l:=min(length(s),(81-x) div 8);
   for i:=0 to l-1 do
      begin
      c:=s[i+1];
      sw:=char48(c);
      for j:=0 to 3 do putxy(x+i*8,y+j,f,b,copy(sw,j*8+1,8))
      end;
end;

procedure put48c(y,f,b: integer; s: str080);
var
   i,j,k,l          : integer;
begin
   l:=min(10,length(s));
   put48(((80-l*8) div 2)+1,y,f,b,s);
end;


(* keyboard *)

procedure inkey(var i:integer);
var
   c                : char;
begin
   i:=0; if not keypressed then exit;
   read(kbd,c);
   if (c=#27) and keypressed then
      begin read(kbd,c); i:=1000+ord(c); exit; end;
   i:=ord(c);
end;

procedure waitkey(var k: integer);
    begin k:=0; while (k=0) do inkey(k); end;

procedure pause;
      var key       : integer;
    begin key:=0; while key=0 do inkey(key); end;

procedure drainkey;
var
   i,j,k   : integer;
begin
   j:=0;
   while (j=0) do
      begin
      i:=0;
      repeat
         i:=i+1;
         inkey(k);
         if (k<>0) then i:=100;
      until (i=100);
      if (k=0) then j:=1;
      end;
end;

function keywinks(x,y: integer; s: str080): integer;
var
   i,j,k,l          : integer;
begin
   l:=length(s);
   putxy(x,y,15,0,s);
   repeat
      i:=random(l);
      putxy(i+x,y,random(8)+7,0,s[i+1]);
      inkey(k);
   until (k<>0);
   keywinks:=k;
end;



(******************             HOLG1000.INC              *******************)
